<?php
define('API_URL', "https://payqr.ru/shop/api/1.0"); // Не меняйте этот адрес без получения официальных извещений PayQR
/**
 * Проверка конфигурации библиотеки PayQR
 */
class payqr_base
{
  /**
   * Эквивалент apache_request_headers()
   * @return mixed
   */
  function getallheaders()
  {
    foreach ($_SERVER as $name => $value) {
      if (substr($name, 0, 5) == 'HTTP_') {
        $name = str_replace(' ', '-', str_replace('_', ' ', substr($name, 5)));
        $headers[$name] = $value;
      } else {
        if ($name == "CONTENT_TYPE") {
          $headers["Content-Type"] = $value;
        } else {
          if ($name == "CONTENT_LENGTH") {
            $headers["Content-Length"] = $value;
          }
        }
      }
    }
    return $headers;
  }

  /**
   * Эквивалент http_build_query() из PHP 5
   * @param $data
   * @param null $prefix
   * @param string $sep
   * @param string $key
   * @return string
   */
  function http_build_query($data, $prefix = null, $sep = '', $key = '')
  {
    $ret = array();
    foreach ((array )$data as $k => $v) {
      $k = urlencode($k);
      if (is_int($k) && $prefix != null) {
        $k = $prefix . $k;
      }
      if (!empty($key)) {
        $k = $key . "[" . $k . "]";
      }
      if (is_array($v) || is_object($v)) {
        array_push($ret, http_build_query($v, "", $sep, $k));
      } else {
        array_push($ret, $k . "=" . urlencode($v));
      }
    }
    if (empty($sep)) {
      $sep = ini_get("arg_separator.output");
    }
    return implode($sep, $ret);
  }

  /**
   * Эквивалент http_build_query() из PHP 5
   * @param $filename
   * @param $data
   * @return bool|int
   */
  function file_put_contents($filename, $data)
  {
    $f = @fopen($filename, 'a');
    if (!$f) {
      return false;
    } else {
      $bytes = fwrite($f, $data);
      fclose($f);
      return $bytes;
    }
  }

  /**
   * Эквивалент json_encode() из PHP 5
   * @param $data
   * @return mixed
   */
  function json_encode($data)
  {
    $json = new Services_JSON();
    return ($json->encode($data));
  }

  /*
   * Эквивалент json_decode() из PHP 5
   */
  function json_decode($data)
  {
    $json = new Services_JSON();
    return ($json->decode($data));
  }

  /**
   * Преобразование utf8
   * @param $data
   * @return mixed
   */
  function encode($data){
    return preg_replace_callback(
      '/\\\\u([0-9a-f]{4})/i', 'payqr_x_callback', $data
    );
  }
}

function payqr_x_callback ($val){
  return mb_decode_numericentity('&#'.intval($val[1], 16).';', array(0, 0xffff, 0, 0xffff), 'utf-8');
}