<?php

/**
 * Реализация запросов в PayQR
 */
class payqr_base_request
{
  var $curl;
  var $e;

  function payqr_base_request()
  {
    if(function_exists('curl_init')){
      $this->curl = new payqr_curl();
    }
    else{
      $this->curl = new payqr_no_curl();
    }
    $this->curl->headers['PQRSecretKey'] = SECRET_KEY_OUT;
    $this->curl->headers['Content-Type'] = 'application/json';
    $this->curl->headers['Content-Length'] = '0';
  }

  /**
   * Отправка POST-запроса
   * @param $url
   * @param array $vars
   * @return mixed|string
   */
  function post($url, $vars = array())
  {
    $response = $this->curl->post($url, $vars);
    var_dump($response);
    if ($this->check_response($response)) {
      return $response->body;
    }
    return false;
  }

  /**
   * Отправка GET-запроса
   * @param $url
   * @param array $vars
   * @return mixed|string
   */
  function get($url, $vars = array())
  {
    $response = $this->curl->get($url, $vars);
    var_dump($response);
    if ($this->check_response($response)) {
      return $response->body;
    }
    return false;
  }

  /**
   * Проверяем ответ от PayQR на отправленный запрос в PayQR
   */
  function check_response($response)
  {
    // Проверяем что ответ не пустой
    if (empty($response)) {
      $this->e = new payqr_exeption("Получен пустой ответ", 0);
      return false;
    }
    // Проверяем код ответа
    if (!isset($response->headers['Status-Code'])) {
      $this->e = new payqr_exeption("Отсутствует заголовок с кодом ответа " . print_r($response, true), 0, $response);
      return false;
    }
    // Проверяем код ответа
    if ($response->headers['Status-Code'] != '200' && $response->headers['Status-Code'] != '100') {
      $this->e = new payqr_exeption("Получен ответ с кодом ошибки " . $response->headers['Status-Code'] . " " . print_r(
        $response,
        true
      ), 0, $response);
      return false;
    }
    // Проверяем заголовок ответа
    if (!payqr_authentication::checkHeader(SECRET_KEY_IN, $response->headers)) {
      $this->e = new payqr_exeption("Неверный параметр ['PQRSecretKey'] в headers ответа" . print_r(
        $response,
        true
      ), 0, $response);
      return false;
    }
    return true;
  }
} 