<?php
/**
 * Формирование товарных позиций в кнопке PayQR
 */

class payqr_product {
  /**
   * Внутренний идентификатор товарной позиции интернет-сайта (артикул)
   * @var
   */  
  var $article;
  
  /**
   * Название товарной позиции
   * @var
   */  
  var $name;  
  
  /**
   * Абсолютная ссылка на изображение товарной позиции
   * @var
   */  
  var $imageurl;

  /**
   * Стоимость всей товарной позиции (цена товарной единицы, умноженная на количество)
   * @var
   */  
  var $amount;

  /**
   * Количество товарных единиц в товарной позиции
   * @var
   */  
  var $quantity;

  /**
   * Категория товарной позиции в соответствии с классификатором товаров/услуг PayQR (необязательно)
   * @var
   */
  var $category; 

  /**
   * Создание товарной позиции
   * @param $article
   * @param $name
   * @param $amount
   * @param $quantity
   * @param $category 
   * @param string $imageurl
   */
  function payqr_product($article, $name, $amount, $quantity, $category, $imageurl=""){
    $this->article = $article;
    $this->name = $name;
    $this->imageurl = $imageurl;
    $this->amount = $amount;
    $this->quantity = $quantity;
	$this->category = $category;
    return $this;
  }

  /**
   * Возвращает массив товарной позиции
   * @return array
   */
  function getArray(){
    return array(
      'article' => $this->article,
      'name' => $this->name,
      'imageurl' => $this->imageurl,
      'amount' => $this->amount,
      'quantity' => $this->quantity,
      'category' => $this->category,	  
    );
  }
}